#include <cassert>

#include <iomanip>
using std::setw;

#include <iostream>
using std::ostream;

void format(ostream &os, const double[], int);

void format(ostream &os, const double[], int, int);

double determinant2(const double[4]);

double determinant3(const double A[9]);

double determinant(const double[], int, int N1 = -1, int* row_index = NULL, int* column_index = NULL);

double inner_prod(const double[], const double[], int);

void outer_prod(double[], const double[], const double[], int, int);

void multiply(double[], const double[], const double[], int, int, int);

void multiply_Rtranspose(double[], const double[], const double[], int, int, int);

